/*
 *	chasm.h - chasm header file
 *
 *	@(#)chasm.h	1.1 91/04/10
 *
 *	Copyright (c) 1991 Steve Scherf
 *
 *	Author:	Steve Scherf
 *	Date:	Wed Apr 10 22:53:11 PDT 1991
 *----------------------------------------------------------------------
 *	Amiga porting:
 *	
 *	By:	Gian Uberto Lauri
 *	Date: Wed Jun 19 1991
 *
 * Notes:
 *	This file is included in the archive to help "yaccless" (or
 *	"bisonless") people and was generated on an Olivetti LSX3020
 *	(Nevertheless it works fine :) :) :) ) of the 'Dipartimento di
 *	Elettronica e Informatica' of Padova University.
 *
 *----------------------------------------------------------------------
 *	SUPERCHIPextension:
 *	
 *	By:	Gian Uberto Lauri
 *	Date: Mon Jun 24 1991
 *
 * Notes:
 *	I added the new tokens last, without care of their alphabetic
 *	order. I choosed 3 letters mnemonics for sake of consistency
 *	with the old code, and in most case they are acronyms.
 *
 *	ESA	Extended Screen Activation (Sorry, On wasn't a good choice)
 *	ESO	Extended Screen Off
 *	BYE	BYE (leave superchip - that's not an acronym :) )
 *	SDP	Set Digit Pointer
 *	WUF	Write User Flags (shut up doggie!)
 *	RUF	Read User Flags
 *	SCD	Scroll down n pixel
 *	SCR	Scroll right 4 pixel
 *	SCL	Scroll left 4 pixel
 *
 *	For more details about S-CHIP, see the relative posting.
 *	BTW, adding new instructions using bison/yacc is trivial.
 */

# line 44 "grammar.y"
#include <stdio.h>

extern char *vartab[];
extern int bcnt;
extern int svin;
int lineno = 1;
int pars_err;

# define STRING 257
# define REG 258
# define VAR 259
# define CONST 260
# define LABEL 261
# define ADD 262
# define AND 263
# define BCD 264
# define CLD 265
# define DATA 266
# define DEF 267
# define DMP 268
# define DSP 269
# define INK 270
# define JMP 271
# define JOF 272
# define JSR 273
# define MEM 274
# define MOV 275
# define OR 276
# define RES 277
# define RET 278
# define RND 279
# define SAR 280
# define SEQ 281
# define SHL 282
# define SHR 283
# define SIP 284
# define SNE 285
# define SNP 286
# define SSC 287
# define SUB 288
# define XOR 289
# define ESA 290
# define ESO 291
# define BYE 292
# define SDP 293
# define WUF 294
# define RUF 295
# define SCD 296
# define SCR 297
# define SCL 298
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 430 "grammar.y"
	/* C code */

yyerror(s)
char *s;
{
	fprintf(stderr,"line %d: %s\n", lineno, s);
	pars_err = 1;
}
yytabelem yyexca[] ={
-1, 1,
	0, -1,
	10, 4,
	-2, 0,
	};
# define YYNPROD 60
# define YYLAST 255
yytabelem yyact[]={

     3,   127,    54,   109,   129,    41,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39,    40,    63,    64,    46,    47,    75,   125,    46,
    47,    69,    53,    46,    47,    46,    47,    45,   124,    46,
    47,    46,    47,   114,   115,   112,   113,   104,   105,   123,
   122,   121,   120,   119,   118,   117,   116,   111,   106,   103,
    82,    81,    80,    79,    78,    77,    76,    73,    72,    71,
    68,    66,    65,    57,    55,    49,    48,    51,    52,    84,
   128,   102,   101,    44,   100,    99,    98,    97,    96,    95,
    56,    94,    58,    59,    60,    61,    62,    93,    92,    91,
    67,    90,    70,    89,    88,    87,    74,    86,    85,    43,
    42,   108,    50,     2,     1,     0,     0,    83,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   107,     0,   110,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   126,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    53,     0,
    53,    46,    47,    46,    47 };
yytabelem yypact[]={

 -1000,  -256,   120,   119,  -201,  -162,  -163, -1000,  -205,  -259,
  -164,  -199,  -165,  -199,  -199,  -199,  -199,  -215,  -166,  -167,
 -1000,  -199,  -168,  -207,  -169,  -170,  -171,  -211,  -172,  -173,
  -174,  -175, -1000, -1000, -1000,  -176,  -177,  -178,  -199, -1000,
 -1000,    41, -1000, -1000,    84,    83, -1000, -1000,    81, -1000,
    80, -1000, -1000, -1000,    79, -1000,    77, -1000, -1000, -1000,
 -1000, -1000,    75,    74,    73,    67, -1000,    65,    64,    63,
    62, -1000, -1000, -1000,    61,    60, -1000, -1000,    58,    57,
 -1000, -1000, -1000, -1000, -1000,  -179,  -191,  -180,    -7,  -199,
  -181,  -193,  -195,  -182,  -183,  -184,  -185,  -186,  -187,  -188,
  -189,  -200,  -210, -1000, -1000, -1000, -1000, -1000,    -9, -1000,
 -1000,    56, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,  -254, -1000 };
yytabelem yypgo[]={

     0,   134,   133,    98,   132,    97,   131 };
yytabelem yyr1[]={

     0,     1,     1,     1,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     4,     4,     4,     5,     5,     3,     3,     6,     6 };
yytabelem yyr2[]={

     0,     0,     7,     7,     0,     9,     9,     9,     9,     5,
     3,     5,     9,     5,    13,     5,     5,     5,     5,     5,
     9,     9,     9,     9,     9,     9,     5,     3,     9,     9,
     9,     9,     5,     5,     5,     9,     9,     5,     5,     9,
     9,     3,     3,     3,     5,     5,     5,     5,     3,     3,
     5,     2,     6,     8,     3,     3,     3,     3,     3,     5 };
yytabelem yychk[]={

 -1000,    -1,    -2,   256,   262,   263,   264,   265,   266,   267,
   268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
   278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
   288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
   298,   261,    10,    10,    -3,   258,   260,   261,   258,   258,
    -4,    -5,    -3,   257,   261,   258,    -3,   258,    -3,    -3,
    -3,    -3,    -3,   258,   259,   258,   258,    -3,   258,   258,
    -3,   258,   258,   258,    -3,   258,   258,   258,   258,   258,
   258,   258,   258,    -3,    58,    44,    44,    44,    44,    44,
    44,    44,    44,    44,    44,    44,    44,    44,    44,    44,
    44,    44,    44,   258,   258,   259,   258,    -5,    -6,    10,
    -3,   258,   258,   259,   258,   259,   258,   258,   258,   258,
   258,   258,   258,   258,   258,   258,    -5,    10,    44,   258 };
yytabelem yydef[]={

     1,    -2,     0,     0,     0,     0,     0,    10,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    41,    42,    43,     0,     0,     0,     0,    48,
    49,     0,     2,     3,     0,     0,    56,    57,     0,     9,
    11,    51,    54,    55,     0,    13,     0,    15,    16,    17,
    18,    19,     0,     0,     0,     0,    26,     0,     0,     0,
     0,    32,    33,    34,     0,     0,    37,    38,     0,     0,
    44,    45,    46,    47,    50,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     5,     6,     7,     8,    52,     0,    58,
    12,     0,    20,    22,    21,    23,    24,    25,    28,    29,
    30,    31,    35,    36,    39,    40,    53,    59,     0,    14 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"STRING",	257,
	"REG",	258,
	"VAR",	259,
	"CONST",	260,
	"LABEL",	261,
	"ADD",	262,
	"AND",	263,
	"BCD",	264,
	"CLD",	265,
	"DATA",	266,
	"DEF",	267,
	"DMP",	268,
	"DSP",	269,
	"INK",	270,
	"JMP",	271,
	"JOF",	272,
	"JSR",	273,
	"MEM",	274,
	"MOV",	275,
	"OR",	276,
	"RES",	277,
	"RET",	278,
	"RND",	279,
	"SAR",	280,
	"SEQ",	281,
	"SHL",	282,
	"SHR",	283,
	"SIP",	284,
	"SNE",	285,
	"SNP",	286,
	"SSC",	287,
	"SUB",	288,
	"XOR",	289,
	"ESA",	290,
	"ESO",	291,
	"BYE",	292,
	"SDP",	293,
	"WUF",	294,
	"RUF",	295,
	"SCD",	296,
	"SCR",	297,
	"SCL",	298,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"line : /* empty */",
	"line : line inst '\n'",
	"line : line error '\n'",
	"inst : /* empty */",
	"inst : ADD const ',' REG",
	"inst : ADD REG ',' REG",
	"inst : ADD REG ',' VAR",
	"inst : AND REG ',' REG",
	"inst : BCD REG",
	"inst : CLD",
	"inst : DATA dlist",
	"inst : DEF LABEL ',' const",
	"inst : DMP REG",
	"inst : DSP const ',' REG ',' REG",
	"inst : INK REG",
	"inst : JMP const",
	"inst : JOF const",
	"inst : JSR const",
	"inst : MEM const",
	"inst : MOV const ',' REG",
	"inst : MOV REG ',' REG",
	"inst : MOV const ',' VAR",
	"inst : MOV REG ',' VAR",
	"inst : MOV VAR ',' REG",
	"inst : OR REG ',' REG",
	"inst : RES REG",
	"inst : RET",
	"inst : RND const ',' REG",
	"inst : SAR REG ',' REG",
	"inst : SEQ REG ',' REG",
	"inst : SEQ const ',' REG",
	"inst : SHL REG",
	"inst : SHR REG",
	"inst : SIP REG",
	"inst : SNE const ',' REG",
	"inst : SNE REG ',' REG",
	"inst : SNP REG",
	"inst : SSC REG",
	"inst : SUB REG ',' REG",
	"inst : XOR REG ',' REG",
	"inst : ESA",
	"inst : ESO",
	"inst : BYE",
	"inst : SDP REG",
	"inst : WUF REG",
	"inst : RUF REG",
	"inst : SCD const",
	"inst : SCR",
	"inst : SCL",
	"inst : LABEL ':'",
	"dlist : dlent",
	"dlist : dlist ',' dlent",
	"dlist : dlist ',' newln dlent",
	"dlent : const",
	"dlent : STRING",
	"const : CONST",
	"const : LABEL",
	"newln : '\n'",
	"newln : newln '\n'",
};
#endif /* YYDEBUG */
/*	@(#)yaccpar	5.1		*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** global variables used by the parser
*/
YYSTYPE yyv[ YYMAXDEPTH ];	/* value stack */
int yys[ YYMAXDEPTH ];		/* state stack */

YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ YYMAXDEPTH ] )	/* room on stack? */
		{
			yyerror( "yacc stack overflow" );
			YYABORT;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 2:
# line 105 "grammar.y"
{
			lineno++;
		} break;
case 3:
# line 110 "grammar.y"
{
			lineno++;
			yyerrok;
		} break;
case 5:
# line 118 "grammar.y"
{
			add_inst(lineno, 0x7, yypvt[-0], 1, 0x0, 0, yypvt[-2], 2);
		} break;
case 6:
# line 123 "grammar.y"
{
			add_inst(lineno, 0x8, yypvt[-0], 1, yypvt[-2], 1, 0x4, 1);
		} break;
case 7:
# line 128 "grammar.y"
{
			if(yypvt[-0] == 2)
				add_inst(lineno, 0xF, yypvt[-2], 1, 0x0, 0, 0x1E, 2);
			else
				yyerror("illegal variable usage");
		} break;
case 8:
# line 136 "grammar.y"
{
			add_inst(lineno, 0xF, yypvt[-2], 1, yypvt[-0], 1, 0x2, 1);
		} break;
case 9:
# line 141 "grammar.y"
{
			add_inst(lineno, 0xF, yypvt[-0], 1, 0x0, 0, 0x33, 2);
		} break;
case 10:
# line 146 "grammar.y"
{
			add_inst(lineno, 0x0, 0x0, 0, 0x0, 0, 0x0E0, 3);
		} break;
case 11:
# line 151 "grammar.y"
{
			add_str_list();
		} break;
case 12:
# line 156 "grammar.y"
{
			register int i;

			i = add_lab(yypvt[-2]);
			lineno++;
			add_val(i, yypvt[-0]);
			lineno--;
		} break;
case 13:
# line 166 "grammar.y"
{
			add_inst(lineno, 0xF, yypvt[-0], 1, 0x0, 0, 0x55, 2);
		} break;
case 14:
# line 171 "grammar.y"
{
			add_inst(lineno, 0xD, yypvt[-2], 1, yypvt[-0], 1, yypvt[-4], 1);
		} break;
case 15:
# line 176 "grammar.y"
{
			add_inst(lineno, 0xF, yypvt[-0], 1, 0x0, 0, 0x0A, 2);
		} break;
case 16:
# line 181 "grammar.y"
{
			add_inst(lineno, 0x1, 0x0, 0, 0x0, 0, yypvt[-0], 3);
		} break;
case 17:
# line 186 "grammar.y"
{
			add_inst(lineno, 0xB, 0x0, 0, 0x0, 0, yypvt[-0], 3);
		} break;
case 18:
# line 191 "grammar.y"
{
			add_inst(lineno, 0x2, 0x0, 0, 0x0, 0, yypvt[-0], 3);
		} break;
case 19:
# line 196 "grammar.y"
{
			add_pad(yypvt[-0]);
		} break;
case 20:
# line 201 "grammar.y"
{
			add_inst(lineno, 0x6, yypvt[-0], 1, 0x0, 0, yypvt[-2], 2);
		} break;
case 21:
# line 206 "grammar.y"
{
			add_inst(lineno, 0x8, yypvt[-0], 1, yypvt[-2], 1, 0x0, 1);
		} break;
case 22:
# line 211 "grammar.y"
{
			if(yypvt[-0] == 2)
				add_inst(lineno, 0xA, 0x0, 0, 0x0, 0, yypvt[-2], 3);
			else
				yyerror("illegal variable usage");
		} break;
case 23:
# line 219 "grammar.y"
{
			switch(yypvt[-0]) {
			    case 0:
				add_inst(lineno, 0xF, yypvt[-2], 1, 0x0, 0, 0x15, 2);
				break;
			    case 1:
				add_inst(lineno, 0xF, yypvt[-2], 1, 0x0, 0, 0x18, 2);
				break;
			    case 2:
				yyerror("illegal variable usage");
				break;
			}
		} break;
case 24:
# line 234 "grammar.y"
{
			if(yypvt[-2] == 0)
				add_inst(lineno, 0xF, yypvt[-0], 1, 0x0, 0, 0x07, 2);
			else
				yyerror("illegal variable usage");
		} break;
case 25:
# line 242 "grammar.y"
{
			add_inst(lineno, 0x8, yypvt[-0], 1, yypvt[-2], 1, 0x1, 1);
		} break;
case 26:
# line 247 "grammar.y"
{
			add_inst(lineno, 0xF, yypvt[-0], 1, 0x0, 0, 0x65, 2);
		} break;
case 27:
# line 252 "grammar.y"
{
			add_inst(lineno, 0x0, 0x0, 0, 0x0, 0, 0x0EE, 3);
		} break;
case 28:
# line 257 "grammar.y"
{
			add_inst(lineno, 0xC, yypvt[-0], 1, 0x0, 0, yypvt[-2], 2);
		} break;
case 29:
# line 262 "grammar.y"
{
			add_inst(lineno, 0x8, yypvt[-0], 1, yypvt[-2], 1, 0x7, 1);
		} break;
case 30:
# line 267 "grammar.y"
{
			add_inst(lineno, 0x5, yypvt[-2], 1, yypvt[-0], 1, 0x0, 1);
		} break;
case 31:
# line 272 "grammar.y"
{
			add_inst(lineno, 0x3, yypvt[-0], 1, 0x0, 0, yypvt[-2], 2);
		} break;
case 32:
# line 277 "grammar.y"
{
			add_inst(lineno, 0x8, yypvt[-0], 1, 0x0, 0, 0x0E, 2);
		} break;
case 33:
# line 282 "grammar.y"
{
			add_inst(lineno, 0x8, yypvt[-0], 1, 0x0, 0, 0x06, 2);
		} break;
case 34:
# line 287 "grammar.y"
{
			add_inst(lineno, 0xE, yypvt[-0], 1, 0x0, 0, 0x9E, 2);
		} break;
case 35:
# line 292 "grammar.y"
{
			add_inst(lineno, 0x4, yypvt[-0], 1, 0x0, 0, yypvt[-2], 2);
		} break;
case 36:
# line 297 "grammar.y"
{
			add_inst(lineno, 0x9, yypvt[-2], 1, yypvt[-0], 1, 0x0, 1);
		} break;
case 37:
# line 302 "grammar.y"
{
			add_inst(lineno, 0xE, yypvt[-0], 1, 0x0, 0, 0xA1, 2);
		} break;
case 38:
# line 307 "grammar.y"
{
			add_inst(lineno, 0xF, yypvt[-0], 1, 0x0, 0, 0x29, 2);
		} break;
case 39:
# line 312 "grammar.y"
{
			add_inst(lineno, 0x8, yypvt[-0], 1, yypvt[-2], 1, 0x5, 1);
		} break;
case 40:
# line 317 "grammar.y"
{
			add_inst(lineno, 0x8, yypvt[-0], 1, yypvt[-2], 1, 0x3, 1);
		} break;
case 41:
# line 321 "grammar.y"
{
			add_inst(lineno, 0x0, 0x0, 0, 0x0, 0, 0x0FE, 3);
		} break;
case 42:
# line 326 "grammar.y"
{
			add_inst(lineno, 0x0, 0x0, 0, 0x0, 0, 0x0FF, 3);
		} break;
case 43:
# line 331 "grammar.y"
{
			add_inst(lineno, 0x0, 0x0, 0, 0x0, 0, 0x0FD, 3);
		} break;
case 44:
# line 336 "grammar.y"
{
			add_inst(lineno, 0xF, yypvt[-0], 1, 0x0, 0, 0x30, 2);
		} break;
case 45:
# line 341 "grammar.y"
{
			if ( yypvt[-0] > 7 )
				yyerror("invalid register set for RPLdata passing");
			else
				add_inst(lineno, 0xF, yypvt[-0], 1, 0x0, 0, 0x75, 2);
		} break;
case 46:
# line 349 "grammar.y"
{
			if ( yypvt[-0] > 7 )
				yyerror("invalid register set for RPLdata passing");
			else
				add_inst(lineno, 0xF, yypvt[-0], 1, 0x0, 0, 0x85, 2);
		} break;
case 47:
# line 357 "grammar.y"
{
			if ( yypvt[-0] > 0xF )
				yyerror("nibble constant too large");
			else
				add_inst(lineno, 0x0, 0x0, 1, 0xC, 1, yypvt[-0], 1);
		} break;
case 48:
# line 364 "grammar.y"
{
			add_inst(lineno, 0x0, 0x0, 0, 0x0, 0, 0x0FB, 3);
		} break;
case 49:
# line 369 "grammar.y"
{
			add_inst(lineno, 0x0, 0x0, 0, 0x0, 0, 0x0FC, 3);
		} break;
case 50:
# line 374 "grammar.y"
{
			if(svin != -1) {
				add_val(svin, 0);
				yyerror("duplicate label");
			}
			svin = add_lab(yypvt[-1]);
		} break;
case 54:
# line 389 "grammar.y"
{
			add_con(lineno, yypvt[-0]);
			yyval = yypvt[-0];
		} break;
case 55:
# line 395 "grammar.y"
{
			add_str(lineno, (char *)yypvt[-0]);
			yyval = yypvt[-0];
		} break;
case 56:
# line 402 "grammar.y"
{
			if(yypvt[-0] > 0xFFF || yypvt[-0] < 0) {
				yyerror("constant out of range");
				yyval = 0;
			}
			else
				yyval = yypvt[-0];
		} break;
case 57:
# line 412 "grammar.y"
{
			register int i;

			i = add_lab(yypvt[-0]);
			yyval = ((i + 1) << 12) + 0xFFF;
		} break;
case 58:
# line 420 "grammar.y"
{
			lineno++;
		} break;
case 59:
# line 425 "grammar.y"
{
			lineno++;
		} break;
	}
	goto yystack;		/* reset registers in driver code */
}
